Subject: Re: [PATCH] soc: ti: ti_sci_pm_domains: Store device id in platform device

From: Lokesh Vutla <[email-masked]>
Date: Tue, 24 Sep 2019 10:15:15 +0530

Hi Tero,

On 23/09/19 12:07 PM, Tero Kristo wrote:
> On 23/09/2019 06:34, Lokesh Vutla wrote:
>> Device ID that is passed from power-domains is used by peripheral
>> drivers for communicating with sysfw. Instead of individual drivers
>> traversing power-domains entry in DT node, store the device ID in
>> platform_device so that drivers can directly access it.
> 
> Uhm, isn't this kind of wrong place to allocate the ID? The power domain

I do agree that this might not be a right place, but I couldn't find a better
place to populate id. Below is the flow on how platform_device gets created.
of_platform_default_populate_init
	->of_platform_default_populate
		-> of_platform_populate
			->of_platform_bus_create
				-> of_platform_device_create_pdata
					-> of_device_alloc
						-> platform_device_alloc("", PLATFORM_DEVID_NONE);

At this point platform_device gets created with dummy device_id. Also there are
no hooks to add custom device_ids.

> solution itself is a client also. In theory, someone could access the pdev->id

Nope, this is done in dev_pm_domain_attach which is called before driver probe
in platform_drv_probe().

> before this. pdev->id should be assigned by bus driver so that it can be
> properly handled within platform_device_add.

DT doesn't provide any such facility for populating device_add. I am open for
any suggestions :)

Thanks and regards,
Lokesh

> 
> -Tero
> 
>>
>> Signed-off-by: Lokesh Vutla <[email-masked]>
>> ---
>>   drivers/soc/ti/ti_sci_pm_domains.c | 2 ++
>>   1 file changed, 2 insertions(+)
>>
>> diff --git a/drivers/soc/ti/ti_sci_pm_domains.c
>> b/drivers/soc/ti/ti_sci_pm_domains.c
>> index 8c2a2f23982c..a124ac409124 100644
>> --- a/drivers/soc/ti/ti_sci_pm_domains.c
>> +++ b/drivers/soc/ti/ti_sci_pm_domains.c
>> @@ -116,6 +116,7 @@ static int ti_sci_pd_attach_dev(struct generic_pm_domain
>> *domain,
>>       struct of_phandle_args pd_args;
>>       struct ti_sci_pm_domain *ti_sci_genpd = genpd_to_ti_sci_pd(domain);
>>       const struct ti_sci_handle *ti_sci = ti_sci_genpd->ti_sci;
>> +    struct platform_device *pdev = to_platform_device(dev);
>>       struct ti_sci_genpd_dev_data *sci_dev_data;
>>       struct generic_pm_domain_data *genpd_data;
>>       int idx, ret = 0;
>> @@ -129,6 +130,7 @@ static int ti_sci_pd_attach_dev(struct generic_pm_domain
>> *domain,
>>           return -EINVAL;
>>         idx = pd_args.args[0];
>> +    pdev->id = idx;
>>         /*
>>        * Check the validity of the requested idx, if the index is not valid
>>
> 
> -- 
> Texas Instruments Finland Oy, Porkkalankatu 22, 00180 Helsinki.
> Y-tunnus/Business ID: 0615521-4. Kotipaikka/Domicile: Helsinki

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel